CREATE OR REPLACE PROCEDURE GERA_REANALISE
AS
   V_IDGERAREANALISE  VARCHAR2(1);
   V_SEQUENCIAL       VARCHAR2(20);
   V_DTVALANA         VARCHAR2(50);
   V_AUDITORIA        VARCHAR2(10);
   V_NEWNRINSPECAUDI  VARCHAR2(3);
   V_DSLIMIINSP       VARCHAR2(50);
   V_CONTRESP         VARCHAR2(10);
   V_DSERROINSPECPROD VARCHAR2(700);
   V_DSERRORESPOS     VARCHAR2(700);
   V_DSERRO           VARCHAR2(700);
   V_CDRESPINSPEC     VARCHAR2(5);
   V_NMRESPINSPEC     VARCHAR2(50);
   V_VRPONTRESINS     FLOAT;
   V_QTESTOQDIA       FLOAT;
   V_IDFAIXRESINS     VARCHAR2(1);
   V_VRINIFAIXRES     FLOAT;
   V_VRFINFAIXRES     FLOAT;
   V_EXISTITEM        NUMBER;
   V_CONTITEM         NUMBER;
   V_DTPRXCONSULTA    DATE;
   V_COUNTINSPECPROD  NUMBER;
   V_COUNTRESPOSTA    NUMBER;
   V_NEWSEQERRO       NUMBER(10);
   V_EXISTERESPOSTA   BOOLEAN;
   V_IDCTRLESTQ       VARCHAR2(01);
   V_IDCNTRESTOQ      VARCHAR2(01);
   V_BOGERAANA        VARCHAR2(05);
   V_CDALMOXLIB       VARCHAR2(06);
   V_CDALMOXQUAR      VARCHAR2(06);
   V_IDUTILALMOX      VARCHAR2(01);
   V_IDUTILLCESTQ     VARCHAR2(01);
   V_IDUTSEGLIBLOTE   VARCHAR2(01);
   V_IDLIBLOTEEST     VARCHAR2(01);
   V_IDPRODPILOTO     VARCHAR2(01);
   V_CDLOCALLIB       VARCHAR2(06);
   V_CDLOCALQUAR      VARCHAR2(06);
   V_NRLANESTENTR     VARCHAR2(10);
   V_NRLANESTSAID     VARCHAR2(10);
   V_VRFATOCONV       FLOAT;
   V_CDPRODESTO       VARCHAR2(20);
   V_VRUNILANCTO      FLOAT;
   V_VRLANCTOBRUT     FLOAT;
   V_DATAPROC         DATE;
   V_DTINICIAL        DATE;
   V_DTFINAL          DATE;
   V_ERROESTOQ        INTEGER;
   V_NRCTRLMOVEST     VARCHAR2(10);
   V_NRORDPROD        VARCHAR2(10);
   V_NRSUBORDPROD     VARCHAR2(01);
   V_DSERROESTOQ      VARCHAR2(700);
BEGIN
   -- BUSCA AS AUDITORIAS VENCIDAS.  USADO SEMPRE A ULTIMA AUDITORIA POR FILIAL, LOTE E PRODUTO
   FOR C_AUDITORIA IN(
      SELECT MAX(B.NRAUDITORIA) NRAUDITORIA, A.CDFILIAL , A.NRLOTEESTQ,A.NRSUBLOTE,
             A.IDTPAUDITADO, A.CDPRODUTO, A.NMPRODUTO, NVL(A.NRDIASVALANA, 0) NRDIASVALANA, A.QTAMOSAUDI,
             B.IDSTATUSAUDI, B.DTFINREALAUD
        FROM AUDITORIA B,
         (SELECT DISTINCT A.CDFILIAL, A.NRLOTEESTQ, A.NRSUBLOTE,
                         A.IDTPAUDITADO, A.CDPRODUTO, P.NMPRODUTO, NVL(P.NRDIASVALANA, 0) AS NRDIASVALANA, A.QTAMOSAUDI
              FROM AUDITORIA A, PRODUTO P
             WHERE A.CDPRODUTO = P.CDPRODUTO
               AND A.DTVALANA BETWEEN TRUNC(SYSDATE, 'MM') AND SYSDATE
               AND A.IDORIGAUDIT = 'ANA'
               AND A.IDSTATUSAUDI IN (4,5)
               AND NVL(A.IDGERADOREANA, 'N') = 'N')A
       WHERE A.CDFILIAL = B.CDFILIAL AND
             A.NRLOTEESTQ = B.NRLOTEESTQ AND
             A.NRSUBLOTE  = B.NRSUBLOTE AND
             A.CDPRODUTO  = B.CDPRODUTO
      GROUP BY A.CDFILIAL, A.NRLOTEESTQ, A.NRSUBLOTE,
              A.IDTPAUDITADO, A.CDPRODUTO, A.NMPRODUTO, A.NRDIASVALANA,
              A.QTAMOSAUDI, B.IDSTATUSAUDI, B.DTFINREALAUD
      ORDER BY NRAUDITORIA)

   LOOP
      -- INICIALIZA A VARIVEL DE ERRO PARA GRAVAR FUTUROS ERROS
      V_DSERROINSPECPROD := NULL;
      V_DSERRORESPOS     := NULL;
      V_EXISTITEM        := 0;
      V_EXISTERESPOSTA   := FALSE;
      V_QTESTOQDIA       := 0;
      V_BOGERAANA        := 'TRUE';
      -- Verifica se o parmetro est marcado para gerar a reanlise
      SELECT NVL(IDGERAREANALISE, 'N') AS IDGERAREANALISE
        INTO V_IDGERAREANALISE
        FROM PARAMETROQPR
       WHERE CDFILIAL = C_AUDITORIA.CDFILIAL;

      IF (V_IDGERAREANALISE = 'S') THEN
         -- VERIFICA SE EXISTE O LOTE NO ESTOQUE
         IF (C_AUDITORIA.NRLOTEESTQ IS NOT NULL) THEN
            SELECT NVL(IDCTRLESTQ, 'S') IDCTRLESTQ
              INTO V_IDCTRLESTQ
              FROM PARAMFILIAL
             WHERE CDFILIAL = C_AUDITORIA.CDFILIAL;

            SELECT NVL(IDCNTRESTOQ, 'S') IDCNTRESTOQ
              INTO V_IDCNTRESTOQ
              FROM PRODFILI
             WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
               AND CDPRODUTO = C_AUDITORIA.CDPRODUTO;

            IF ((V_IDCTRLESTQ <> 'N') AND (V_IDCNTRESTOQ <> 'N')) THEN
               BEGIN
                  SELECT NVL(SUM(ROUND(QTESTOQDIA,5)), 0) QTESTOQDIA
                    INTO V_QTESTOQDIA
                    FROM POSESTDIA B, PRODUTO P
                   WHERE (B.CDFILIAL   = C_AUDITORIA.CDFILIAL)
                     AND (B.NRLOTEESTQ = C_AUDITORIA.NRLOTEESTQ)
                     AND (B.NRSUBLOTE  = NVL(C_AUDITORIA.NRSUBLOTE, ' '))
                     AND (P.CDPRODUTO  = C_AUDITORIA.CDPRODUTO)
                     AND (B.CDPRODUTO  = P.CDPRODESTO)
                     AND (B.DTPOSIESTQ = (SELECT MAX(P.DTPOSIESTQ)
                                            FROM POSESTDIA P
                                           WHERE P.CDFILIAL      = B.CDFILIAL
                                             AND P.CDPRODUTO     = B.CDPRODUTO
                                             AND P.CDALMOXARIFE = B.CDALMOXARIFE
                                             AND P.CDLOCALESTOQ = B.CDLOCALESTOQ
                                             AND P.NRLOTEESTQ    = B.NRLOTEESTQ
                                             AND P.NRSUBLOTE     = B.NRSUBLOTE
                                             AND P.DTPOSIESTQ    <= SYSDATE+1));
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_QTESTOQDIA := 0;
               END;

               IF NOT(V_QTESTOQDIA > 0) THEN
                  V_BOGERAANA := 'FALSE';
               END IF;
            END IF;

         END IF;

         IF ((C_AUDITORIA.NRLOTEESTQ IS NOT NULL) AND (V_BOGERAANA = 'TRUE')) OR (C_AUDITORIA.NRLOTEESTQ IS NOT NULL) THEN

            -- INSERE A AUDITORIA/REANLISE
            NOVO_CODIGO_SC('AUDITORIA'||C_AUDITORIA.CDFILIAL, V_SEQUENCIAL);
            V_SEQUENCIAL := SUBSTR(V_SEQUENCIAL, 11,10);

            V_DTVALANA := VALIDADE_ANA(C_AUDITORIA.CDFILIAL, '', 'QPR', C_AUDITORIA.NRLOTEESTQ, C_AUDITORIA.NRSUBLOTE, 'R', C_AUDITORIA.CDPRODUTO);


            --  INSERIR AUDITORIA
            INSERT INTO AUDITORIA
            (NRLOTEESTQ,   NRSUBLOTE,    CDPRODUTO,
            IDSTATUSAUDI,  CDFILIAL, DTINCLAUDIT, QTAMOSAUDI,
            NRAUDITORIA,  IDORIGAUDIT,  CDSETEXECAUD,  DSREFEAUDIT,
            IDLIBERAUDIT,   IDTPAUDITADO, DTVALANA, IDGERADOJOB, IDTIPOANA)
            values
            (C_AUDITORIA.NRLOTEESTQ,   C_AUDITORIA.NRSUBLOTE, C_AUDITORIA.CDPRODUTO,
            '1', C_AUDITORIA.CDFILIAL,  SYSDATE, C_AUDITORIA.QTAMOSAUDI,
            V_SEQUENCIAL,  'ANA',  '', 'Reanlise gerada automaticamente',
            'S', C_AUDITORIA.IDTPAUDITADO, V_DTVALANA, 'S', 'R');
            V_AUDITORIA := V_SEQUENCIAL;

            --Verifica se existe inspeo do produto cadastrado
            BEGIN
               SELECT COUNT(*)
                 INTO V_COUNTINSPECPROD
                 FROM INSPECAO ICAO,
                      INSPECPROD IPRO
                WHERE (IPRO.CDPRODUTO    = C_AUDITORIA.CDPRODUTO)  AND
                      (IPRO.CDINSPECAO   = ICAO.CDINSPECAO)        AND
                      (IPRO.IDPROCPROD = C_AUDITORIA.IDTPAUDITADO) AND
                      (ICAO.IDORIGINSPEC = 'ANA')                  AND
                      (ICAO.IDSITINSPEC = 'A')                     AND
                      (IPRO.IDSTATUSINSPEC = 'A');
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_COUNTINSPECPROD := 0;
            END;

            IF V_COUNTINSPECPROD = 0 THEN
               V_DSERROINSPECPROD := 'No existe cadastro na tela de ProdutoXAnlise ou os cadastros se encontram inativos';
            END IF;

            -- VERIFICA SE EXISTE INSPECAO
            FOR C_INSPECPROD IN(
               SELECT IPRO.CDSETOR, ICAO.IDORIGINSPEC, ICAO.CDNVINSPECAO, IPRO.IDPROCPROD,
                      ICAO.CDINSPECAO, ICAO.CDARVINSPEC
                 FROM INSPECAO ICAO,
                      INSPECPROD IPRO
                WHERE (IPRO.CDPRODUTO    = C_AUDITORIA.CDPRODUTO)  AND
                      (IPRO.CDINSPECAO   = ICAO.CDINSPECAO)        AND
                      (IPRO.IDPROCPROD = C_AUDITORIA.IDTPAUDITADO) AND
                      (ICAO.IDORIGINSPEC = 'ANA')                  AND
                      (ICAO.IDSITINSPEC = 'A')                     AND
                      (IPRO.IDSTATUSINSPEC = 'A')
               ORDER BY IPRO.CDSETOR)
            LOOP
               -- INSERE A INSPECAO DA AUDITORIA
               BEGIN
                  SELECT LPAD((NVL(MAX(NRINSPECAUDI), '0') + 1), 3, '0')
                    INTO V_NEWNRINSPECAUDI
                    FROM INSPECAUDIT
                   WHERE CDFILIAL    = C_AUDITORIA.CDFILIAL
                     AND NRAUDITORIA = V_AUDITORIA;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NEWNRINSPECAUDI := NULL;
               END;

               INSERT INTO INSPECAUDIT
               (CDFILIAL, NRAUDITORIA,  NRINSPECAUDI, IDINSPCONC,
                CDINSPECAO, DSINSPECAUDI, IDNOVAAMOSTR, IDTIPOINSAUD)
               VALUES
               (C_AUDITORIA.CDFILIAL, V_AUDITORIA,  V_NEWNRINSPECAUDI, 'P',
               C_INSPECPROD.CDINSPECAO, '',   'N', 'R');

               --Verifica se existe resposta da inspeo cadastrado
               BEGIN
                  SELECT COUNT(*)
                    INTO V_COUNTRESPOSTA
                    FROM RESPOSINSPEC R, INSPECAO I
                   WHERE (I.CDARVINSPEC LIKE (C_INSPECPROD.CDARVINSPEC || '%')) AND
                         (I.IDSITINSPEC  = 'A')                                 AND
                         (R.CDINSPECAO   = I.CDINSPECAO)                        AND
                         (R.CDPRODUTO    = C_AUDITORIA.CDPRODUTO)               AND
                         (R.IDSTATUSRESP = 'A')                                 AND
                         (I.IDATEITEINSP = 'I');
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_COUNTRESPOSTA := 0;
               END;

               IF (V_COUNTRESPOSTA = 0) AND (V_EXISTERESPOSTA = FALSE) THEN
                  V_DSERRORESPOS :=  'No existe resposta cadastrada ou ativa para a inspeo.';
                  V_EXISTERESPOSTA := FALSE;
               ELSE
                  V_EXISTERESPOSTA := TRUE;
               END IF;

               -- BUSCA AS RESPOSTAS
               FOR C_INSPECRESP IN(
                  SELECT I.CDINSPECAO, I.CDTIPOAMOS, I.IDTPRESPINSP, R.CDRESPINSPEC, I.IDATEITEINSP
                    FROM RESPOSINSPEC R, INSPECAO I
                   WHERE (I.CDARVINSPEC LIKE (C_INSPECPROD.CDARVINSPEC || '%')) AND
                         (I.IDSITINSPEC  = 'A')                                 AND
                         (R.CDINSPECAO   = I.CDINSPECAO)                        AND
                         (R.CDPRODUTO    = C_AUDITORIA.CDPRODUTO)               AND
                         (R.IDSTATUSRESP = 'A')                                 AND
                         (I.IDATEITEINSP = 'I')
                       ORDER BY I.CDINSPECAO, R.VRPONTRESINS)
               LOOP
                  V_DSLIMIINSP := '';
                  IF (C_INSPECRESP.IDTPRESPINSP = 'VALR') THEN
                     BEGIN
                        SELECT CDRESPINSPEC, NMRESPINSPEC, VRPONTRESINS, IDFAIXRESINS,
                               VRINIFAIXRES, VRFINFAIXRES
                          INTO V_CDRESPINSPEC, V_NMRESPINSPEC, V_VRPONTRESINS, V_IDFAIXRESINS,
                               V_VRINIFAIXRES, V_VRFINFAIXRES
                          FROM RESPOSINSPEC
                         WHERE (CDINSPECAO = C_INSPECRESP.CDINSPECAO)     AND
                               (CDPRODUTO  = C_AUDITORIA.CDPRODUTO  )     AND
                               (IDRESPPROC = C_INSPECPROD.IDPROCPROD)     AND
                               (VRPONTRESINS = '0')                       AND
                               (CDRESPINSPEC = C_INSPECRESP.CDRESPINSPEC) AND
                               (IDSTATUSRESP  = 'A');
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_CDRESPINSPEC := NULL;
                           V_NMRESPINSPEC := NULL;
                           V_VRPONTRESINS := NULL;
                           V_IDFAIXRESINS := NULL;
                           V_VRINIFAIXRES := NULL;
                           V_VRFINFAIXRES := NULL;
                     END;

                     IF NOT (V_CDRESPINSPEC IS NULL) THEN
                        IF V_IDFAIXRESINS = '>' THEN
                           V_DSLIMIINSP := 'Maior que '||TO_CHAR(V_VRINIFAIXRES);
                        END IF;
                        IF V_IDFAIXRESINS = '<' THEN
                           V_DSLIMIINSP := 'Menor que '||TO_CHAR(V_VRINIFAIXRES);
                        END IF;
                        IF V_IDFAIXRESINS = '=' THEN
                           V_DSLIMIINSP := 'Entre '||TO_CHAR(V_VRINIFAIXRES)||' e '||TO_CHAR(V_VRFINFAIXRES);
                        END IF;
                        ELSE
                           V_DSLIMIINSP := '';
                     END IF;
                  END IF;

                  SELECT COUNT(*)
                    INTO V_EXISTITEM
                    FROM ITEMINSAUDIT
                   WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                     AND NRAUDITORIA = V_AUDITORIA
                     AND NRINSPECAUDI = V_NEWNRINSPECAUDI
                     AND CDINSPECAO = C_INSPECRESP.CDINSPECAO;

                  IF V_EXISTITEM = 0 THEN
                     INSERT INTO ITEMINSAUDIT
                     (CDFILIAL,      NRAUDITORIA,   NRINSPECAUDI,    CDINSPECAO,
                      IDOPCACEITIN,  DSOBSINSAUDI, DSLIMIINSP)
                     VALUES
                     (C_AUDITORIA.CDFILIAL,  V_AUDITORIA,  V_NEWNRINSPECAUDI,  C_INSPECRESP.CDINSPECAO,
                      'P',  '', V_DSLIMIINSP);
                  END IF;
               END LOOP;
            END LOOP;

            -- EXLUI AS INSPECOES DA AUDITORIA QUE NAO POSSUEM ITEM DO TIPO INDISPENSVEL
            FOR C_BUSCAINSPECAO IN(
               SELECT CDFILIAL, NRINSPECAUDI, CDINSPECAO
                 FROM INSPECAUDIT
                WHERE NRAUDITORIA = V_AUDITORIA)
            LOOP
               BEGIN
                  SELECT COUNT(*) AS CONTITEM
                    INTO V_CONTITEM
                    FROM ITEMINSAUDIT
                   WHERE CDFILIAL     = C_AUDITORIA.CDFILIAL
                     AND NRAUDITORIA  = V_AUDITORIA
                     AND NRINSPECAUDI = C_BUSCAINSPECAO.NRINSPECAUDI;
               EXCEPTION
                    WHEN NO_DATA_FOUND THEN
                       V_CONTITEM := 0;
               END;

               IF (V_CONTITEM = 0) THEN
                  DELETE FROM INSPECAUDIT
                    WHERE CDFILIAL     = C_BUSCAINSPECAO.CDFILIAL
                      AND NRAUDITORIA  = V_AUDITORIA
                      AND NRINSPECAUDI = C_BUSCAINSPECAO.NRINSPECAUDI;
                END IF;
            END LOOP;
         END IF;
      END IF;

      -- Se ocorrer algum erro, a auditoria no  inserida e o erro  gravado no banco
      IF V_DSERROINSPECPROD IS NULL AND (V_DSERRORESPOS IS NULL OR V_EXISTERESPOSTA = TRUE) THEN

         --ALTERA A AUDITORIA PARA QUE NO SEJA GERADA OUTRA REANLISE PARA ELA
         UPDATE AUDITORIA
           SET IDGERADOREANA = 'S'
          WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
            AND NRAUDITORIA = C_AUDITORIA.NRAUDITORIA;

          IF C_AUDITORIA.IDSTATUSAUDI = '4' THEN --CONCLUIDO OK

             V_CDALMOXLIB := ' ';
             V_CDALMOXQUAR := ' ';
             SELECT MAX(IDUTILALMOX),  MAX(IDUTILLCESTQ)
               INTO V_IDUTILALMOX,  V_IDUTILLCESTQ
               FROM PARAMFILIAL
              WHERE CDFILIAL = C_AUDITORIA.CDFILIAL;

             IF V_IDUTILALMOX = 'S' THEN
                IF C_AUDITORIA.IDTPAUDITADO = 'A' THEN --PRODUTO ACABADO
                   SELECT NVL(MAX(M.IDUTSEGLIBLOTE), 'N') AS IDUTSEGLIBLOTE, MAX(M.IDLIBLOTEEST)
                     INTO V_IDUTSEGLIBLOTE, V_IDLIBLOTEEST
                     FROM PARAMAN M
                    WHERE CDFILIAL = C_AUDITORIA.CDFILIAL;
                   IF ((V_IDUTSEGLIBLOTE = 'S') AND (V_IDLIBLOTEEST <> '1')) THEN
                      SELECT MAX(CDALMOXPRACA), MAX(CDALMOXQUAR)
                        INTO V_CDALMOXLIB, V_CDALMOXQUAR
                        FROM PRODFILI
                       WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                         AND CDPRODUTO = C_AUDITORIA.CDPRODUTO;
                   END IF;
                ELSE
                   IF C_AUDITORIA.IDTPAUDITADO = 'P' THEN --SEMI ACABADO
                      SELECT MAX(CDALMOXPRSEMACA), MAX(CDALMOXARIFE)
                        INTO V_CDALMOXLIB, V_CDALMOXQUAR
                        FROM PRODFILI
                       WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                         AND CDPRODUTO = C_AUDITORIA.CDPRODUTO;
                   ELSE
                      --MATEIRA PRIMA
                      SELECT MAX(NRORDPROD), MAX(NRSUBORDPROD)
                        INTO V_NRORDPROD, V_NRSUBORDPROD
                        FROM AUDITORIA
                       WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                         AND NRAUDITORIA = C_AUDITORIA.NRAUDITORIA;

                      SELECT NVL(MAX(O.IDPRODPILOTO),'N')
                        INTO V_IDPRODPILOTO
                        FROM ORDPRODUCAO O
                       WHERE O.CDFILIAL     = C_AUDITORIA.CDFILIAL
                         AND O.NRORDPROD    = V_NRORDPROD
                         AND O.NRSUBORDPROD = V_NRSUBORDPROD
                         AND O.CDPRODUTO    = C_AUDITORIA.CDPRODUTO;

                      IF V_IDPRODPILOTO = 'S' THEN
                         SELECT MAX(CDALMOXINSPRPIL), MAX(CDALMOXQUAMPPIL)
                           INTO V_CDALMOXLIB, V_CDALMOXQUAR
                           FROM PRODFILI
                          WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                            AND CDPRODUTO = C_AUDITORIA.CDPRODUTO;
                      ELSE
                         SELECT MAX(CDALMOXINSPR), MAX(CDALMOXARIFE)
                           INTO V_CDALMOXLIB, V_CDALMOXQUAR
                           FROM PRODFILI
                          WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                            AND CDPRODUTO = C_AUDITORIA.CDPRODUTO;
                      END IF;

                   END IF;
                END IF;

                V_CDLOCALLIB := ' ';
                V_CDLOCALQUAR := ' ';
                IF (V_IDUTILLCESTQ = 'S') THEN
                   IF C_AUDITORIA.IDTPAUDITADO = 'A' THEN --PRODUTO ACABADO
                      SELECT NVL(MAX(M.IDUTSEGLIBLOTE), 'N') AS IDUTSEGLIBLOTE, MAX(M.IDLIBLOTEEST)
                        INTO V_IDUTSEGLIBLOTE, V_IDLIBLOTEEST
                        FROM PARAMAN M
                       WHERE CDFILIAL = C_AUDITORIA.CDFILIAL;
                      IF ((V_IDUTSEGLIBLOTE = 'S') AND (V_IDLIBLOTEEST <> '1')) THEN
                         SELECT MAX(CDLOCALPRACA), MAX(CDLOCALQUAR)
                           INTO V_CDLOCALLIB, V_CDLOCALQUAR
                           FROM PRODFILI
                          WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                            AND CDPRODUTO = C_AUDITORIA.CDPRODUTO;
                      END IF;
                   ELSE
                      IF C_AUDITORIA.IDTPAUDITADO = 'P' THEN --SEMI ACABADO
                         SELECT MAX(CDLOCALPRSEMACA), MAX(CDLOCALESTOQ)
                           INTO V_CDLOCALLIB, V_CDLOCALQUAR
                           FROM PRODFILI
                          WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                            AND CDPRODUTO = C_AUDITORIA.CDPRODUTO;
                      ELSE
                         --MATEIRA PRIMA
                         SELECT MAX(NRORDPROD), MAX(NRSUBORDPROD)
                           INTO V_NRORDPROD, V_NRSUBORDPROD
                           FROM AUDITORIA
                          WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                            AND NRAUDITORIA = C_AUDITORIA.NRAUDITORIA;

                         SELECT NVL(MAX(O.IDPRODPILOTO),'N')
                           INTO V_IDPRODPILOTO
                           FROM ORDPRODUCAO O
                          WHERE O.CDFILIAL     = C_AUDITORIA.CDFILIAL
                            AND O.NRORDPROD    = V_NRORDPROD
                            AND O.NRSUBORDPROD = V_NRSUBORDPROD
                            AND O.CDPRODUTO    = C_AUDITORIA.CDPRODUTO;

                         IF V_IDPRODPILOTO = 'S' THEN
                            SELECT MAX(CDLOCALINSPRPIL), MAX(CDLOCALQUAMPPIL)
                              INTO V_CDLOCALLIB, V_CDLOCALQUAR
                              FROM PRODFILI
                             WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                               AND CDPRODUTO = C_AUDITORIA.CDPRODUTO;
                         ELSE
                            SELECT MAX(CDLOCALINSPR), MAX(CDLOCALESTOQ)
                              INTO V_CDLOCALLIB, V_CDLOCALQUAR
                              FROM PRODFILI
                             WHERE CDFILIAL = C_AUDITORIA.CDFILIAL
                               AND CDPRODUTO = C_AUDITORIA.CDPRODUTO;
                         END IF;

                      END IF;
                   END IF;
                END IF;

                SELECT MAX(VRFATOCONV), MAX(CDPRODESTO)
                  INTO V_VRFATOCONV, V_CDPRODESTO
                  FROM PRODUTO P
                 WHERE CDPRODUTO = C_AUDITORIA.CDPRODUTO;

                IF ((V_CDLOCALLIB IS NULL) OR (V_CDLOCALLIB = '')) THEN
                   V_CDLOCALLIB := ' ';
                END IF;
                IF ((V_CDLOCALQUAR IS NULL) OR (V_CDLOCALQUAR = '')) THEN
                   V_CDLOCALQUAR := ' ';
                END IF;

                BEGIN
                   SELECT SUM(D.QTESTOQDIA/P.VRFATOCONV) AS QTESTOQDIA,
                          DECODE(QTESTOQDIA, 0, DECODE(QTESTOQANT, 0, 0, VRESTOQANT/QTESTOQANT), VRESTOQDIA/QTESTOQDIA)  AS VRCUSTOPROD,
                          DECODE(QTESTOQDIA, 0, DECODE(QTESTOQANT, 0, 0, VRBRUTOANT/QTESTOQANT), VRESTOQBRUT/QTESTOQDIA) AS VRCUSTOBRUT
                     INTO V_QTESTOQDIA, V_VRUNILANCTO, V_VRLANCTOBRUT
                     FROM PRODUTO P, POSESTDIA D, PRODFILI F
                    WHERE (P.CDPRODUTO    = C_AUDITORIA.CDPRODUTO)
                      AND (D.CDFILIAL     = C_AUDITORIA.CDFILIAL)
                      AND (D.CDALMOXARIFE = NVL(V_CDALMOXLIB, ' '))
                      AND (D.CDLOCALESTOQ = NVL(V_CDLOCALLIB, ' '))
                      AND (D.NRLOTEESTQ   = NVL(C_AUDITORIA.NRLOTEESTQ,   ' '))
                      AND (D.NRSUBLOTE    = NVL(C_AUDITORIA.NRSUBLOTE,    ' '))
                      AND (D.CDPRODUTO    = P.CDPRODESTO)
                      AND (P.CDPRODESTO   = F.CDPRODUTO)
                      AND (F.CDFILIAL     = C_AUDITORIA.CDFILIAL)
                      AND (DTPOSIESTQ = (SELECT MAX(DTPOSIESTQ)
                                           FROM POSESTDIA
                                          WHERE (CDFILIAL     = C_AUDITORIA.CDFILIAL)
                                            AND (CDALMOXARIFE = NVL(V_CDALMOXLIB, ' '))
                                            AND (CDLOCALESTOQ = NVL(V_CDLOCALLIB, ' '))
                                            AND (NRLOTEESTQ   = NVL(C_AUDITORIA.NRLOTEESTQ,   ' '))
                                            AND (NRSUBLOTE    = NVL(C_AUDITORIA.NRSUBLOTE,    ' '))
                                            AND (CDPRODUTO    = P.CDPRODESTO)
                                            AND (DTPOSIESTQ  <= (SYSDATE+1))))
                      GROUP BY DECODE(QTESTOQDIA, 0, DECODE(QTESTOQANT, 0, 0, VRESTOQANT/QTESTOQANT), VRESTOQDIA/QTESTOQDIA),
                               DECODE(QTESTOQDIA, 0, DECODE(QTESTOQANT, 0, 0, VRBRUTOANT/QTESTOQANT), VRESTOQBRUT/QTESTOQDIA);
                EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_QTESTOQDIA   := 0;
                      V_VRUNILANCTO  := 0;
                      V_VRLANCTOBRUT := 0;
                END;

                IF (V_QTESTOQDIA > 0) THEN
                   --SAIDA
                   NOVO_CODIGO('LANCTOEST'||C_AUDITORIA.CDFILIAL,V_NRLANESTSAID);
                   V_NRLANESTSAID := SUBSTR(V_NRLANESTSAID,11,10);

                   INSERT INTO LANCTOESTOQ
                   (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ,
                    DSLANCESTQ, CDFILIMOVI)
                   VALUES
                   (C_AUDITORIA.CDFILIAL, V_NRLANESTSAID, '4', TRUNC(C_AUDITORIA.DTFINREALAUD),
                    'Lanc.Ref. Reanlise gerada automaticamente. N '||V_SEQUENCIAL, C_AUDITORIA.CDFILIAL);

                   INSERT INTO ITLANCTOEST
                   (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,
                    QTLANCTOEST, IDTIPOMOVI, DTLANCMOVI, IDORDEMCLC,
                    VRUNILANCTO, VRTOTLANCTO, VRLANCTOEST, VRLANCTOBRUT,
                    QTTOTLANCTO, CDFILIMOVI, CDPRODMOVI, IDEVOLESTOQ,
                    CDALMOXARIFE, CDLOCALESTOQ , NRLOTEESTQ , NRSUBLOTE)
                   VALUES
                   (C_AUDITORIA.CDFILIAL, V_NRLANESTSAID, '0001', C_AUDITORIA.CDPRODUTO,
                    (V_QTESTOQDIA/V_VRFATOCONV), '4', TRUNC(C_AUDITORIA.DTFINREALAUD), '4',
                    (V_VRUNILANCTO * V_VRFATOCONV), ((V_QTESTOQDIA/V_VRFATOCONV) * (V_VRUNILANCTO * V_VRFATOCONV)), (V_VRUNILANCTO * V_VRFATOCONV), V_VRLANCTOBRUT,
                    (V_QTESTOQDIA/V_VRFATOCONV), C_AUDITORIA.CDFILIAL, V_CDPRODESTO, 'S',
                    V_CDALMOXLIB, NVL(V_CDLOCALLIB, ' ') , C_AUDITORIA.NRLOTEESTQ , C_AUDITORIA.NRSUBLOTE);

                    SELECT DECODE(PG.IDUTILDTPROC,'S', NVL(PF.DTPROCESSA, SYSDATE), SYSDATE)
                      INTO V_DATAPROC
                      FROM PARAMFILIAL PF, (SELECT IDUTILDTPROC
                                              FROM PARAMGERAL
                                             WHERE CDPARGERAL = '0001') PG
                     WHERE PF.CDFILIAL = C_AUDITORIA.CDFILIAL;


                    IF TRUNC(C_AUDITORIA.DTFINREALAUD) < V_DATAPROC THEN
                       V_DTINICIAL := TRUNC(C_AUDITORIA.DTFINREALAUD);
                    ELSE
                       V_DTINICIAL := V_DATAPROC;
                    END IF;

                    IF TRUNC(C_AUDITORIA.DTFINREALAUD) > V_DATAPROC THEN
                       V_DTFINAL := TRUNC(C_AUDITORIA.DTFINREALAUD);
                    ELSE
                       V_DTFINAL := V_DATAPROC;
                    END IF;

                   ATUALIZA_ESTOQUE(C_AUDITORIA.CDFILIAL, V_DTINICIAL, V_DTFINAL, C_AUDITORIA.CDFILIAL, V_NRLANESTSAID);

                   SELECT COUNT(1)
                     INTO V_ERROESTOQ
                     FROM MOVILOTE
                    WHERE (NRMOVILOTE  = C_AUDITORIA.CDFILIAL||V_NRLANESTSAID);

                   IF (V_ERROESTOQ > 0) THEN
                      V_DSERROESTOQ := 'Estoque irregular';
                   END IF;

                   --ENTRADA
                   NOVO_CODIGO('LANCTOEST'||C_AUDITORIA.CDFILIAL,V_NRLANESTENTR);
                   V_NRLANESTENTR := SUBSTR(V_NRLANESTENTR,11,10);

                   INSERT INTO LANCTOESTOQ
                   (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ,
                    DSLANCESTQ, CDFILIMOVI)
                   VALUES
                   (C_AUDITORIA.CDFILIAL, V_NRLANESTENTR, '2', TRUNC(C_AUDITORIA.DTFINREALAUD),
                    'Lanc.Ref. Reanlise gerada automaticamente. N '||V_SEQUENCIAL, C_AUDITORIA.CDFILIAL);

                   INSERT INTO ITLANCTOEST
                   (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,
                    QTLANCTOEST, IDTIPOMOVI, DTLANCMOVI, IDORDEMCLC,
                    VRUNILANCTO, VRTOTLANCTO, VRLANCTOEST, VRLANCTOBRUT,
                    QTTOTLANCTO, CDFILIMOVI, CDPRODMOVI, IDEVOLESTOQ,
                    CDALMOXARIFE, CDLOCALESTOQ , NRLOTEESTQ , NRSUBLOTE)
                   VALUES
                   (C_AUDITORIA.CDFILIAL, V_NRLANESTENTR, '0001', C_AUDITORIA.CDPRODUTO,
                    (V_QTESTOQDIA/V_VRFATOCONV), '2', TRUNC(C_AUDITORIA.DTFINREALAUD), '2',
                    (V_VRUNILANCTO * V_VRFATOCONV), ((V_QTESTOQDIA/V_VRFATOCONV) * (V_VRUNILANCTO * V_VRFATOCONV)), (V_VRUNILANCTO * V_VRFATOCONV), V_VRLANCTOBRUT,
                    (V_QTESTOQDIA/V_VRFATOCONV), C_AUDITORIA.CDFILIAL, V_CDPRODESTO, 'S',
                    V_CDALMOXQUAR, NVL(V_CDLOCALQUAR, ' ') , C_AUDITORIA.NRLOTEESTQ , C_AUDITORIA.NRSUBLOTE);

                   ATUALIZA_ESTOQUE(C_AUDITORIA.CDFILIAL, V_DTINICIAL, V_DTFINAL, C_AUDITORIA.CDFILIAL, V_NRLANESTENTR);

                   SELECT COUNT(1)
                     INTO V_ERROESTOQ
                     FROM MOVILOTE
                    WHERE (NRMOVILOTE  = C_AUDITORIA.CDFILIAL||V_NRLANESTENTR);

                    IF (V_ERROESTOQ > 0) THEN
                       V_DSERROESTOQ := 'Estoque irregular';
                    END IF;
                    NOVO_CODIGO('NRTRANSESTQ'||C_AUDITORIA.CDFILIAL,V_NRCTRLMOVEST);
                    V_NRCTRLMOVEST := SUBSTR(V_NRCTRLMOVEST,11,10);

                   insert into CTRLMOVIESTQ
                   (CDFILIAL, NRCTRLMOVEST, CDFILIALENTR, NRLANESTENTR, CDFILIALSAID,
                    NRLANESTSAID, CDALMOXENTR, CDALMOXSAID, CDLCESTENTR, CDLCESTSAID,
                    DTMOVIESTQ, IDSISTEMA, DSOPERACAO)
                   values
                    (C_AUDITORIA.CDFILIAL, V_NRCTRLMOVEST, C_AUDITORIA.CDFILIAL, V_NRLANESTENTR,
                     C_AUDITORIA.CDFILIAL, V_NRLANESTSAID, V_CDALMOXQUAR, V_CDALMOXLIB, NVL(V_CDLOCALQUAR, ' '), NVL(V_CDLOCALLIB, ' '),
                     TRUNC(C_AUDITORIA.DTFINREALAUD), 'QPR', 'Reanlise gerada automaticamente');

                END IF;
                IF (V_DSERROESTOQ IS NULL) THEN
                   COMMIT;
                ELSE
                   ROLLBACK;
                   V_DSERRO := V_DSERROESTOQ;
                   BEGIN
                      SELECT LPAD((NVL(MAX(NRSEQERRO), '0') + 1), 3, '0')
                        INTO V_NEWSEQERRO
                        FROM ERROGERAREANA
                       WHERE CDFILIAL    = C_AUDITORIA.CDFILIAL;
                   EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                         V_NEWSEQERRO := NULL;
                   END;

                   INSERT INTO ERROGERAREANA
                   (NRSEQERRO, CDFILIAL, NRAUDITORIA, DSERRO, DTERRO)
                   VALUES
                   (V_NEWSEQERRO, C_AUDITORIA.CDFILIAL, C_AUDITORIA.NRAUDITORIA, V_DSERROESTOQ, SYSDATE);
                   COMMIT;
                END IF;

             END IF;
          END IF;
      ELSE
         ROLLBACK;
         IF (V_DSERROINSPECPROD IS NULL) THEN
            V_DSERRO := V_DSERRORESPOS;
         ELSE
            V_DSERRO := V_DSERROINSPECPROD;
         END IF;

         BEGIN
            SELECT LPAD((NVL(MAX(NRSEQERRO), '0') + 1), 3, '0')
              INTO V_NEWSEQERRO
              FROM ERROGERAREANA
             WHERE CDFILIAL    = C_AUDITORIA.CDFILIAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NEWSEQERRO := NULL;
         END;

         INSERT INTO ERROGERAREANA
         (NRSEQERRO, CDFILIAL, NRAUDITORIA, DSERRO, DTERRO)
         VALUES
         (V_NEWSEQERRO, C_AUDITORIA.CDFILIAL, C_AUDITORIA.NRAUDITORIA, V_DSERRO, SYSDATE);
         COMMIT;
      END IF;

   END LOOP;
   -- Atualiza a data da consulta no banco
   UPDATE PARAMETROQPR
     SET DTULTCONSULTA = SYSDATE;
   COMMIT;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('GERA_REANALISE','6.05.xxx'); END;
/
